#!/usr/bin/env node

const pkg = require('./package.json');

const program = require('commander');

program.version(pkg.version);

const path = require('path'),
    fs = require('fs');

const fh = require('./bin/fileHelper');

program.command('new [template]')
    .description('new an app in the director')
    .option('-o,--output [type]', '输出到新的目录,不传次参数就初始化到当前目录')
    .action(function(template, options) {
        let srcPath = path.join(__dirname, 'src', template);
        let dest = process.cwd();
        if (options.output) {
            dest = path.join(dest, options.output);
            if (!fh.exists(dest)) {
                fs.mkdirSync(dest);
            }
        }
        console.log('正在复制模板文件...');
        fh.copy2(srcPath, dest, true);
        console.log('正在安装依赖...');
        require('child_process').execSync('npm install', {
            encoding: 'utf8',
            timeout: 0,
            maxBuffer: 200 * 1024,
            killSignal: 'SIGTERM',
            cwd: dest,
            env: null
        });

        console.log('恭喜你，模板完成了');
    });

program.command('list')
    .description('列出所以的模板')
    .action(function() {
        let x = require('./bin/list.js');
        for (var key in x) {
            if (x.hasOwnProperty(key)) {
                var t = x[key];
                console.log(key + ':' + t);
            }
        }
    });

program.command('*')
    .action(function(env) {
        console.log('没有参数 "%s"', env);
    });


program.parse(process.argv);