const compose = require('koa-compose');

const fs = require('fs'),
    { join } = require('path');


module.exports = function(root) {
    const routes = [];

    (function readDir(r) {
        let files = fs.readdirSync(root);
        files.forEach(f => {
            let fPath = join(r, f);
            if (fs.statSync(fPath).isDirectory()) {
                readDir(fPath);
            } else if (f.endsWith('.js')) {
                useRoute(fPath);
            }
        });
    })(root)

    function useRoute(routerPath) {
        const route = require(routerPath);
        routes.push(route.routes());
        routes.push(route.allowedMethods());
    }

    return compose(routes);
}